;
;	Filnavn: 	NEWBURN.ASM
;	Besk.:	PIC16x84 seriel programmer
;			modtager med 57600 baud, 8 bit, 1 stopbit
;  			ingen paritet og ingen flowcontrol
;			Passer til 10Mhz krystal
;       	Dato:		29. Marts 2006
;

	processor	16f84a                       		;Dette direktiv angiver hvilken processor MPASM skal genererer kode til
	#include	p16f84a.inc   	               	;Dette direktiv angiver at en filen "p16f84a.inc" skal indsttes p dette sted
	

;	Stter configuration-bits ved at anvende definitioner fra include-filen, p16f84a.inc
	__config	_HS_OSC & _PWRTE_OFF & _WDT_OFF & _CP_OFF

#define		clock		portb,6			;definitioner
#define		dataP 	portb,7			;definitioner
#define		mclr		porta,3			;definitioner
#define		reset		porta,2			;definitioner
#define		clockT	Trisb,6			;definitioner
#define		dataT 	trisb,7 			;definitioner
#define		mclrT  	trisa,3 			;definitioner
#define		resetT	trisa,2 			;definitioner
#define		stat		porta,1			;definitioner
#define		statT		trisa,1 			;definitioner
#define		over2000	flagreg,0			;hvis PC er over 2000hex
#define		over2100	flagreg,1			;hvis PC er over 2100hex

counter		equ		0x0C				;Delay til RS232
BitCounter    	equ		0x0D				;Delay til RS232
Receive		equ		0x0E				;Det modtagne tegn fra RS232
transmit		equ		0x0F				;Tegn til afsendelse p RS232
counter1		equ		0x10				;Delay_10ms routine
counter2		equ 		0x11				;Delay_10ms routine
flagreg		equ		0x12				;register til flag
prog_count      	equ		0x13				;counter til antal byte p hexlinien
prog_adr0	    	equ		0x14				;programadresse (lav)
prog_adr1	    	equ		0x15				;programadresse (hj)
prog_type	    	equ		0x16				;type indikerer sidste linie i hexfilen
prog_con0      	equ		0x17				;configurations-word (lav)
prog_con1      	equ		0x18				;configurations-word (hj)
prog_PicA0   	equ		0x19				;adressen som der brndes p i PIC kredsen (lav)
prog_picA1   	equ 		0x1A				;adressen som der brndes p i PIC kredsen (hj)
prog_data0   	equ		0x1B				;databyte (lav) fra hexlinien
prog_data1   	equ		0x1C				;databyte (hj) fra hexlinien
prog_tdata0   	equ		0x1D				;databyte (lav) til at sammenligne med
prog_tdata1   	equ		0x1F				;databyte (hj) til at sammenligne med
prog_bit_count  	equ		0x20				;bit-counter til seriel-routinerne til pic'en
prog_cmd_data	equ		0x21				;plads til at gemme cmd i
col			equ		0x22				;tller til x-retning
lin			equ		0x23				;tller til y-retning
chksum		equ		0x24				;checksum
extra			equ		0x25				;en extra plads
flashEE		equ		0x26				;fflash = 0 og EE = 1
PrgMem		equ		0x27				;strrelsen af Program memory
DatMem		equ		0x28				;strrelsen af Data memory (EE)

			org		0x0000			;Her starter prog. afviklingen (reset vektor)
			clrf		counter			;delay til RS232
			clrf		counter1			;Delay 10ms
			clrf		counter2			;Delay 10ms
			goto		main				;g til hovedprogtammet
			org 		0x0005			;frste adr. efter interrupt vektor

			#include 	RS232.lib			;indst RS232 bibliotek
main									;**** hovedprogram ****
			bcf		mclr				;mclr lav
			bcf		clock				;clock lav
			bcf		dataP 	          	;data lav
			bcf		stat	   			;fejlindikator lav
			bcf		reset				;normal reset hj
	
			bsf		status,rp0			;definer porte
			bsf		clockT			;indgang
			bsf		dataT         			;indgang
			bcf		mclrT            		;udgang
			bcf		statT				;udgang
			bcf		resetT			;udgang
			bcf		status,rp0			;definition slut
		
			clrf		prog_PicA0   		;\ Reset Pic-
			clrf		prog_PicA1            	;/ adresse tller
			bcf		over2000			;PC er ikke over 2000hex
			bcf		over2100			;PC er ikke over 2100hex

			call		Receive_port		;init  RS232 modtag
			call		transmit_port		;init  RS232 send

        			call    	delay_10ms                 	;\
        			call    	delay_10ms                 	; pause
        			call    	delay_10ms                 	;/

			movlw	'R'				; Skriv et 'READY' p rs232
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'e'				;	"
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'a'				;	"
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'd'				;	"
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'y'				;	"
			movwf	transmit			;	"
			call		Transmit_data		;	"
        			movlw   	D'13'				; (CR)"
			movwf	transmit			;	"
			call		Transmit_data		;	"
        			movlw   	D'10'				; (LF)	"
			movwf	transmit			;	"
			call		Transmit_data		;	"		
endloop								;**** vent p kolon ****
			clrf		receive			;slet indholdet i receive-reg.
			clrw						;slet indholdet i w-reg.
			call		receive_wait               	;vent p et tegn p rs232 (tegnet lander i "receive")
			movf  	receive,w			;Flyt tegnet til W (igen)
			SUBLW	':'				;sammenlign med kolon
			BTFSC	status,Z			;var det et kolon?
			GOTO	start_burn			;hvis ja: start brndingen

			movf  	receive,w	                   	;Flyt tegnet til W (igen)
			SUBLW	'#'				;sammenlign med #
			BTFSC	status,Z			;var det et #?
			GOTO	read_pic			;hvis ja: ls PIC'en

			movf    	receive,w                  	;Flyt tegnet til W (igen)
			SUBLW	''				;sammenlign med 
			BTFSC	status,Z			;var det et ?
			GOTO	slet_pic			;hvis ja: slet PIC'en

			movf    	receive,w                  	;Flyt tegnet til W (igen)
			SUBLW	''				;sammenlign med 
			BTFSC	status,Z			;var det et ?
			GOTO	picburnII			;hvis ja: send ID og et "Ready"

			goto		endloop			;hvis nej: bliv i loopet
;*************************************************************************
picburnII		
			call		read_ID			;ls hvilken PIC som er tilsluttet brnderen
			call		send_ID			;send det til pc-programmet
			GOTO	main				;afslut og send et "Ready"
read_ID
			call		enterPrgMem		;g ind i brnde-mode
			call		delay_10ms               	;pause
			movlw	0xFF				;flyt et tilfldigt tal til W-reg
			movwf	prog_data0                	;put det i adr0
			movwf	prog_data1                	;put det i adr1
			movlw	D'0'				;load config cmd
			call		prog_cmd			;send cmd til pic'en
			call		prog_send_data        	;send data til pic'en
			call		flyt_til_2006   		;flyt til adr. 2006
			movlw	D'4'				;ls data fra prog-mem cmd
			call		prog_cmd			;send cmd til pic'en
			call		read_adr			;ls adresseindhold ind i prog_data0 og prog_data1
			MOVLW	0xE
			SUBWF	prog_data1,w
			BTFSS	status,Z
			BSF		flashEE,1			;flash = 0 og EE = 1
			BTFSC	status,Z
			BCF		flashEE,1
			return
send_ID
			movlw	prog_data1                 	;\ send heigh-byte's
			call		write_ASCII                 	;/ p RS232
			movlw	prog_data0                 	;\ send low-byte's
			call		write_ASCII                 	;/ p RS232
			return
;*************************************************************************
read_pic								;**** Ls indholdet ***
			movlw	PrgMem			;\  ls hvor meget prog. mem der (kommer fra pc-programmet)
			call		read_hex			;/
			movlw	DatMem			;\  ls hvor meget data. mem der (kommer fra pc-programmet)
			call		read_hex			;/
						
			call		enterPrgMem		;g ind i brnde-mode
			call		delay_10ms               	;pause
			clrf		prog_adr0                  	;adr-tller=0 (low)
			clrf		prog_adr1                  	;adr-tller=0 (heigh)

PRloop		movlw	0x80				;lg 128 i w-reg ### skal rettes hvis data er strre end 1024 byte ###
			movwf	lin				;flyt vrdi til y-tller
loop_lin
			movlw	D'8'				;lg 8 i w-reg
			movwf	col				;flyt vrdi til x-tller
			call		prefix				;send prefix
			call		chkstatus			;opdater checksum		
loop_col
			movlw	D'4'				;ls data fra prog-mem cmd
			call		prog_cmd			;send cmd til pic'en
			call		read_adr			;ls adresseindhold ind i prog_data0 og prog_data1
			movlw	prog_data0                 	;\ send low-byte's
			call		write_ASCII                 	;/ p RS232
			movlw	prog_data1                 	;\ send heigh-byte's
			call		write_ASCII                 	;/ p RS232
			movf		prog_data1,w		;w-reg=data1
			addwf	chksum,f			;lg til check sum
			movf		prog_data0,w		;w-reg=data0
			addwf	chksum,f			;lg til check sum
			incf		prog_adr0,f                	;forg adr tller (lav)
			btfsc		status,Z			;(p.g.a. 16 bit)
			incf		prog_adr1,f                 	;forg evt. ogs hj del
			incf		prog_adr0,f                	;forg adr tller (lav)
			btfsc		status,Z			;(p.g.a. 16 bit)
			incf		prog_adr1,f                  	;forg evt. ogs hj del
			movlw	D'6'				;forg adr i pic komandoen
			call		prog_cmd			;send cmd til pic'en
			decfsz	col				;tl ned p x-tller
			goto		loop_col			;hvis ikke 0 fortst i loop
			call		l_f				;send chksum og linefeed
			decfsz	lin				;forminsk y-tller
			goto		loop_lin			;hvis ikke 0 fortst i loop
			decfsz	PrgMem			;forminsk PrgMem-tller
			goto		PRloop			;hvis ikke 0 fortst i loop
									;**** flyt til adresse 2000hex ****
			movlw	0xFF				;flyt et tilfldigt tal til W-reg
			movwf	prog_data0                	;put det i adr0
			movwf	prog_data1                	;put det i adr1
			movlw	D'0'				;load config cmd
			call		prog_cmd			;send cmd til pic'en
			call		prog_send_data        	;send data til pic'en
			movlw	0x40				;\
			movwf	prog_adr1			; st adresse til 4000h
			clrf		prog_adr0			;/
			movlw	':'				;en linie starter med kolon
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			movlw	'0'				;s kommer et 0
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			movlw	'8'				;og dernst et 8
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			call		prefix1			;hent resten af prefix
			movlw	D'8'				;w-reg=8
			movwf	chksum			;flyt til check sum
			movf		prog_adr1,w               	;w-reg= adr1
			addwf	chksum,f			;lg til check sum
			movf		prog_adr0,w                	;w-reg= adr0
			addwf	chksum,f			;lg til check sum
			movlw	D'4'				;lg 4 i w-reg
			movwf	col				;flyt vrdi til x-tller
			call		loop_id			;send data
			call		l_f				;send chksum og linefeed
			movlw	D'6'				;\
			call		prog_cmd			;  \
			movlw	D'6'				;    \ flyt til adr
			call		prog_cmd			;    / 2007hex
			movlw	D'6'				;  / 
			call		prog_cmd			;/
			movlw	0x0E				;\ st adresse 	
			movwf	prog_adr0			;/ til 2007hex
			movlw	':'				;en linie starter med kolon
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			movlw	'0'				;s kommer et 0
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			movlw	'2'				;og dernst et 2
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			call		prefix1			;hent resten af prefix
			movlw	D'2'				;w-reg=2
			movwf	chksum			;flyt til check sum
			movf		prog_adr1,w              	;w-reg= adr1
			addwf	chksum,f			;lg til check sum
			movf		prog_adr0,w              	;w-reg= adr0
			addwf	chksum,f			;lg til check sum
			movlw	D'1'				;lg 1 i w-reg
			movwf	col				;flyt vrdi til x-tller
			call		loop_id			;send data
			call		l_f				;send chksum og linefeed
			bcf		status,C			;\
			rrf		prog_adr1,f                	; divider prog_adrX med 2
			rrf		prog_adr0,f                	;/ (da 4000hex i filen = 2000hex i pic'en)
			incf		prog_adr0,f                 	;forg med 1
mov2100
			movlw	D'6'                                	;forg -
			call		prog_cmd			;pic-adressen med 1
			incf		prog_adr0,f                	;forg adr tller (lav)
			btfsc		status,Z			;(p.g.a. 16 bit)
			incf		prog_adr1,f               	;forg evt. ogs hj del
			movlw	0x21				;lg 21hex i w-reg
			subwf	prog_adr1,w               	;sammenlign med adr1
			btfss		status,Z			;defferens?
			goto		mov2100			;hvis forskel: forg
			bcf		status,C			;\
			rlf		prog_adr0,f                	;  adr x 2
			rlf		prog_adr1,f               	; /
	
DAloop		movlw	D'8'				;st gentagelse til 8 ## skal rettes hvis EE-data er strre end 64 byte ##
			movwf	lin				;flyt vrdien til lin
EEdataX	
			call		prefix				;send liniestart
			call		chkstatus			;opret checksum
			call		EEmem			;send data
			call		l_f				;send chksum og linefeed
			movlw	0x10				;w-reg=10h
			addwf	prog_adr0,f                  	;lg w-reg til adr (low)
			decfsz	lin				;forminsk y-tller
			goto		EEdataX			;hvis ikke nul bliv da i loopet
			decfsz	DatMem			;forminsk DatMem-tller
			goto		DAloop			;hvis ikke nul bliv da i loopet
			movlw	':'				;**** send sidste linie :00000001FF ****
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'0'				;
			call		transmit_data		;
			movlw	'1'				;
			call		transmit_data		;
			movlw	'F'				;
			call		transmit_data		;
			movlw	'F'				;
			call		transmit_data		;
			movlw	D'13'				;
			call		transmit_data		;
			movlw	D'10'				;
			call		transmit_data		;
			goto		main				;lsning frdig
;------------------------------------------------------------------------------------------------
loop_id		movlw	D'4'				;ls data fra prog-mem cmd
			call		prog_cmd			;send cmd til pic'en
			call		read_adr			;ls adresseindhold ind i prog_data0 og prog_data1
			movlw	prog_data0                	;\ send low-byte's
			call		write_ASCII                	;/ p RS232
			movlw	prog_data1                  	;\ send heigh-byte's
			call		write_ASCII                	;/ p RS232
			movf		prog_data1,w		;w-reg=data1
			addwf	chksum,f			;lg til check sum
			movf		prog_data0,w		;w-reg=data0
			addwf	chksum,f			;lg til check sum
			movlw	D'6'				;forg adr i pic komandoen
			call		prog_cmd			;send cmd til pic'en
			decfsz	col				;tl ned p x-tller
			goto		loop_id			;hvis ikke 0 fortst i loop
			return					;vend tilbage
;------------------------------------------------------------------------------------------------
EEmem		movlw 	D'8'				;gentagelsesfaktor
			movwf	col				;lgges i col
loop_EE		movlw	D'5'				;ls data fra prog-mem cmd
			call		prog_cmd			;send cmd til pic'en
			call		read_adr			;ls adresseindhold ind i prog_data0 og prog_data1
			clrf		prog_data1                  	;st data (heigh) til 00h
			movlw	prog_data0                 	;\ send low-byte's
			call		write_ASCII                 	;/ p RS232
			movlw	prog_data1                 	;\ send heigh-byte's
			call		write_ASCII                 	;/ p RS232
			movf		prog_data1,w		;w-reg=data1
			addwf	chksum,f			;lg til check sum
			movf		prog_data0,w		;w-reg=data0
			addwf	chksum,f			;lg til check sum
			movlw	D'6'				;forg adr i pic komandoen
			call		prog_cmd			;send cmd til pic'en
			decfsz	col				;tl ned p x-tller
			goto		loop_EE			;hvis ikke 0 fortst i loop
			return					;vend tilbage
;------------------------------------------------------------------------------------------------
l_f			comf		chksum,f			;2's komplement af checksum
			incf		chksum,f			;forg med 1
			movlw	chksum			;send checksum
			call		write_ASCII                	;p RS232
       			movlw    	D'13'				;\	
			movwf	transmit			;  send CR
			call		Transmit_data		;/  
      			movlw    	D'10'				;\	
			movwf	transmit			;  send LF
			call		Transmit_data		;/  
			return
;------------------------------------------------------------------------------------------------
prefix									;**** linie-prefix ****
			movlw	':'				;en linie starter med kolon
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data             	;send p RS232
			movlw	'1'				;s kommer et 1
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
			movlw	'0'				;og dernst et 0
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send p RS232
prefix1		movlw	prog_adr1			;hent adr (heigh)
			call		write_ASCII                	;send p RS232
			movlw	prog_adr0			;hent adr (low)
			call		write_ASCII                	;send p RS232
			movlw	'0'				;type 00
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data             	;send p RS232
			movlw	'0'				;type 00
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data              	;send p RS232
			return					;retuner
;------------------------------------------------------------------------------------------------
chkstatus								;**** opdater chksum ***
			movlw	D'16'				;2's komplement af antal og type
			movwf	chksum			;flyt til check sum
			movf		prog_adr1,w                	;2's komplement af adr1
			addwf	chksum,f			;lg til check sum
			movf		prog_adr0,w                	;2's komplement af adr0
			addwf	chksum,f			;lg til check sum
			return					;returner
;------------------------------------------------------------------------------------------------
write_ASCII                                                                   	;**** send register som 2 ASCII ****
			movwf	fsr				;peg p filereg (pointer) 
			swapf	indf,f				;byt om p 4 verste og 4 nederste bit
			call		sendNib			;send en ASCII-karakter p RS232
			swapf	indf,f				;byt tilbage igen (og send en ASCII til)
sendNib	
			movf		indf,w                            	;flyt destination til W-reg
			andlw	B'00001111'
			addlw	D'48'				;lg 48 til (svarer til ASCII-nul)
			movwf	extra				;flyt resultat til transmit-reg
			movlw	D'58'
			subwf	extra,w
			btfss		status,C
			goto		sendchr
			movlw	D'7'
			addwf	extra,f
sendchr
			movf		extra,w
			movwf	transmit			;flyt w-reg til transmit
			call		transmit_data		;send ASCII
			return					;vend tilbage
;------------------------------------------------------------------------------------------------
read_adr								;*** ls en adresse ind i 2 reg's ***
			movlw	D'16'				;put 16 i w-reg.
			movwf	prog_bit_count		;st bit-count til 16
			bsf		status,rp0			;\
			bsf		dataT                           	; st dataport til input
			bcf		status,rp0			;/
			nop						;\
			nop						; \ pause
			nop						; /
			nop						;/
read_adr1								;**** loop ****
			bsf		clock				;clock=1
			nop						;pause
			nop						;pause
			bcf		clock				;data klar til lsning
			nop						;pause
			btfsc		dataP                           	;\	
			bsf		status,C			; \ st C = dataport
			btfss		dataP                           	; /
			bcf		status,C			;/
			rrf		prog_data1,f		;roter C ind i data1
			rrf		prog_data0,f		;roter data1 ind i data0
			nop						;pause for at vre sikker
			decf		prog_bit_count		;forminsk bit-counter
			btfss		status,Z			;er den nul?
			goto		read_adr1			;hvis nej: fortst loopet
			bsf		status,rp0			;\
			bcf		dataT                            	; hvis ja: st dataport til output
			bcf		status,rp0			;/
			bcf		prog_data0,0		;\reset start-  
			bcf		prog_data1,7		;/og stop-bit
			bcf		status,C			;st carry = 0
			rrf		prog_data1,f		;roter C ind i data1
			rrf		prog_data0,f		;roter data1 ind i data0
			return					;afslut og vend tilbage (se *)
									;*(prog_data0=adr(low) og prog_data1=adr(heigh)
;*************************************************************************
slet_pic								;**** Slet Pic'en *******
			call		enterPrgMem		;g ind i brnde-mode
			call		delay_10ms                	;pause
			call		sletPic			;slet PIC-kredsen
			goto		main				;sletning frdig
;*************************************************************************
start_burn								;**** start brnding ****
			call		read_ID			;#################### sat ind i forb. med udvikling
			bcf		stat				;fejlindikator lav
			call		enterPrgMem		;g ind i brnde-mode
			call		delay_10ms                 	;pause
			call		sletPic			;anbefalet sletning af pic
LinieStart								;**** ls en linie i hexfilen ****
			movlw	prog_count               	;\ hent count 
			call		read_hex			;/ fra hexlinien
			movlw	prog_adr1                	;\ hent high-byte adr 
			call		read_hex			;/ fra hexlinien
			movlw	prog_adr0                    	;\ hent low-byte adr 
			call		read_hex			;/ fra hexlinien
			bcf		status,C			;\
			rrf		prog_adr1,f                 	; divider prog_adrX med 2
			rrf		prog_adr0,f                	;/ (da 4000hex i filen = 2000hex i pic'en)
			movlw	prog_type			;\ hent type 
			call		read_hex			;/ fra hexlinien
        			movlw 	D'1'	                           	;er det type 01 ?, hvilket betyder 
        			subwf	prog_type,w               	;sidste linie...
        			btfsc		status,Z			;hvis ja - s...
        			goto		burnconf			;brnd config og afslut brnding
			movlw	0x07				; hvis dette er config-word,
			subwf	prog_adr0,w               	; s gem det til sidst og 
			btfss		status,Z			; fortst...
			goto		ikke2007			;
			movlw	0x20				;
			subwf	prog_adr1,w              	;
			btfss		status,Z			;
			goto		ikke2007			;
			call		hent2byte			;
			movf		prog_data0,w		;
			movwf	prog_con0			;
			movf		prog_data1,w   		;
			movwf	prog_con1			;
			incf		prog_picA1,f		;
			decf		prog_count,f   		;
			btfsc		status,z			;
			goto		prog_skip			;
			decf		prog_count,f   		;
			btfsc		status,Z 			;
			goto		prog_skip			;
			btfss		over2000			;
			goto		loadconf			;
			call		opdatPicAdr                	;
			goto		prog_word			;
ikke2007                                                                         	;fortst her hvis adressen ikke er 2007
			btfsc		over2000			;hvis adresse er over 2000
			goto		check2100                 	;s flyt PC til configurations-
			movlw	0x20				;memory....
			subwf	prog_adr1,w               	;
			btfsc		status,Z			;
			goto		loadconf			;
check2100                                                                    	;fortst her hvis adressen ikke er 2000
			btfsc		over2100			;hvis adresse er over 2100
			goto		continue			;s g i EEdata-mode....
			movlw	21h				;
			subwf	prog_adr1,w             	;
			btfsc		status,Z			;
			call		reenterPrgMem		;
continue								;fortst her hvis adressen ikke er 2100
			call		opdatPicAdr                 	;synkroniser pic-adr med prog-adr 
Prog_word                                                                    	;**** programer 2 byte ****
			call		hent2byte			;hent 2 byte fra hexlinien
			movlw	D'2'				;cmd load data for program mem
			btfsc		over2100			;hvis EEdata-mode
			addlw	D'1'				;s: cmd load data for data mem
			call 		prog_cmd			;send cmd til pic'en
			call		prog_send_data       	;send data tilpic'en
hex2000								;start her hvis: kom fra loadcon 
			call		burn_word			;brnd ordet
			decf		prog_count,f   		;forminsk count
			btfsc		status,z			;hvis nul s g til prog_skip
			goto		prog_skip			;(evt. fejlcheck!!)
			decf		prog_count,f   		;forminsk count
			btfss		status,Z 			;hvis nul s g til prog_skip
			goto		prog_word			;ellers fortst med at lse byte fra hexlinien
prog_skip								;**** ls bytes frem til kolon ****
			call		receive_wait                	;hent en byte fra hexlinien
			movlw	':'				;lg et kolon i w
			subwf	receive,w			;trk det fra den lste byte
			BTFSS	status,Z			;var byten et kolon?
			GOTO	prog_skip			;hvis nej, hent da en ny byte fra hexlinien
			goto		liniestart			;hvis ja, g da igang med en ny hexlinie
loadconf								;**** frste gang man nr til config-mem ****
			call		hent2byte			;hent 2 byte fra hexlinien
			movlw	D'0'				;load config cmd
			call		prog_cmd			;send cmd til pic'en
			call		prog_send_data        	;send data til pic'en
			movlw	0x00				;\
			movwf	prog_picA0                	; \ st pic adr
			movlw	0x20				; / til 2000hex
			movwf	prog_picA1                  	;/
			call		opdatPicAdr                 	;synkroniser pic-adr med prog-adr 
			bsf		over2000			;vi er nu i config-Mem omrdet
			goto		hex2000			;spring til prog_word routinen
opdatPicAdr                                                                  	;**** synkroniser adresser ****
			goto 		cmp_picAdr                	;start med at sammenlign prog-adr og pic-adr
inc_picAdr								;****** forg ***********
			movlw	D'6'				;forg adr i pic komandoen
			call		prog_cmd			;send cmd til pic'en
			incf		prog_PicA0,f		;forg pic adr tller (lav)
			btfsc		status,Z			;(p.g.a. 16 bit)
			incf		prog_PicA1,f		;forg evt. ogs hj del
cmp_picAdr                                                                  	;***** sammenlign *******
			movf		prog_adr1,w                	;\
			subwf	prog_PicA1,w		; sammenlign hj del
			btfss		status,Z			;/
			goto		inc_picAdr			; hvis forskel: forg
			movf		prog_adr0,w               	;\
			subwf	prog_PicA0,w		; sammenlign lav del
			btfss		status,Z			;/
			goto		inc_picAdr			; hvis forskel: forg
			return
hent2byte								;**** ls 2 bytes fra hexfilen ****
			movlw	prog_data0                	;i dette register skal byten ligge
			call		read_hex			;hent byten fra hexlinien
			movlw	prog_data1                 	;i dette register skal byten ligge
			call		read_hex			;hent byten fra hexlinien
			return
burn_word								;**** brnd og sammenlign ****
			BTFSS	flashEE,1
			goto		bnfl
									;Denne sekvens hvis PIC'en er en EEPROM*************
			movlw	B'001000'			;cmd begin program
			call		prog_cmd			;send cmd til pic'en
			call		delay_10ms               	;vent 10 ms
			goto		bw_nxt			;g til sammenlign
bnfl									;Denne sekvens hvis PIC'en er en FLASH***************
			movlw	B'011000'			;cmd begin program only
			call		prog_cmd			;send cmd til pic'en
			call		delay_1ms               	;vent 1ms
			movlw	B'10111'			; \ end programming
			call		prog_cmd			; /
bw_nxt
			movlw	D'4'				;read data from prog-mem cmd
			btfsc		over2100			;hvis EEdata-mode s:
			addlw	D'1'				;read data from data mem cmd
			call		prog_cmd			;send cmd til pic'en
			call		prog_compare		;sammenlign det sendte og det lste
			movlw	D'6'				;increment adrs cmd
			call		prog_cmd			;send cmd til pic'en
			incf		prog_picA0,f		;forg pic adr tller (lav)
			btfsc		status,Z			;(p.g.a. 16 bit)
			incf		prog_picA1,f		;forg evt. ogs hj del
			return
prog_cmd								;**** send prog-komando ****
			movwf	prog_cmd_data		;gem kommando der skal sendes
			movlw	D'6'				;put 6 i w-reg.
			movwf	prog_bit_count		;gem 6 i bit-counter
prog_cmd1                                                                   	;*** loop ****
			bsf		clock				;clock=1
			rrf		prog_cmd_data,f       	;roter cmd_data og f bit i c
			btfsc		status,C			;\
			bsf		dataP                           	; \ st data udgangen
			btfss		status,C			; / til det samme som C
			bcf		dataP                          	;/
			nop						;\
			nop						; pause for at vre sikker
			nop						;/
			bcf		clock				;clock=0
			nop						;\ pause for at 
			nop						;/ vre sikker
			decf		prog_bit_count		;forminsk bit-counter
			btfss		status,Z			;er den nul?
			goto		prog_cmd1                 	;hvis nej: fortst loopet
			return					;hvis Ja: afslut og vend tilbage
prog_send_data                                                        	;**** Send 16 bit data ****
			bcf		status,C			;st C = 0
			rlf		prog_data0,f		;\
			rlf		prog_data1,f		; lg 0 i start og slut
			bcf		prog_data1,7		;/
			movf		prog_data0,w		;\
			movwf	prog_tdata0              	; \ gem de 2 data bytes
			movf		prog_data1,w		; / i Tdata 1 og 2
			movwf	prog_tdata1                	;/
			movlw	D'16'				;put 16 i w-reg.
			movwf	prog_bit_count		;gem 16 i bit-counter
prog_send1                                                                 	;**** loop ****
			bsf		clock				;clock=1
			nop						;pause
			nop						;pause
			rrf		prog_data1,f              	;roter data1 over i data0
			rrf		prog_data0,f		;roter data0 og f bit i C
			btfsc		status,C			;\
			bsf		dataP                         	; \ st data udgangen
			btfss		status,C			; / til det samme som C
			bcf		dataP                            	;/
			nop						;pause for at vre sikker
			bcf		clock				;clock=0
			nop						;pause for at vre sikker
			nop						;pause for at vre sikker
			decf		prog_bit_count		;forminsk bit-counter
			btfss		status,Z			;er den nul?
			goto		prog_send1               	;hvis nej: fortst loopet
			return					;hvis Ja: afslut og vend tilbage
prog_compare							;*** sammenlign sendte data med modtaget data ***
			movlw	D'16'				;put 16 i w-reg.
			movwf	prog_bit_count		;st bit-count til 16
			bsf		status,rp0			;\
			bsf		dataT                           	; st dataport til input
			bcf		status,rp0			;/
			nop						;\
			nop						; \ pause
			nop						; /
			nop						;/
prog_cmp1                                                                  	;**** loop ****
			bsf		clock				;clock=1
			nop						;pause
			nop						;pause
			bcf		clock				;data klar til lsning
			nop						;pause
			btfsc		dataP                            	;\
			bsf		STATUS,C			; \ st C = dataport
			btfss		dataP                         	; /
			bcf		STATUS,C			;/
			rrf		prog_data1,f		;roter C ind i data1
			rrf		prog_data0,f		;roter data1 ind i data0
			nop						;pause for at vre sikker
			decf		prog_bit_count		;forminsk bit-counter
			btfss		STATUS,Z			;er den nul?
			goto		prog_cmp1                 	;hvis nej: fortst loopet
			bsf		STATUS,rp0		;\
			bcf		dataT                            	; hvis ja: st dataport til output
			bcf		STATUS,rp0		;/
			bcf		prog_data0,0		;\reset start og stop bit 
			bcf		prog_data1,7		;/fr sammenligning
			movf		prog_data0,w		;\sammenlign
			subwf	prog_Tdata0,w		;/low-byte
			btfss		status,Z			;var de ens?
			goto 		Cmp_error                 	;hvis nej: fejl!!
			btfss		over2100			;hvis ja: er det EEdata?
			call		comp_high                	;hvis nej: sammenlign high-byte
			return					;hvis ja: afslut og vend tilbage
comp_high                                                                	;**** sammenlign high-byte ****
			movf		prog_data1,w		;\sammenlign
			subwf	prog_Tdata1,w		;/high-byte
			btfss		status,Z			;var de ens?
			goto 		Cmp_error                 	;hvis nej: fejl!!
			return					;hvis ja: afslut og vend tilbage
Cmp_error                                                                     	;**** fejl routine ****
			movlw	prog_picA1                 	;\ send heigh-byte's
			call		write_ASCII                 	;/ p RS232
			movlw	prog_picA0                 	;\ send low-byte's
			call		write_ASCII                 	;/ p RS232
			movlw	'E'				;Skriv et 'Error' p rs232
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'r'				;	"
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'r'				;	"	
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'o'				;	"
			movwf	transmit			;	"
			call		Transmit_data		;	"
			movlw	'r'				;	"
			movwf	transmit 			;	"
			call		Transmit_data		;	"
			bsf		stat				;indiker fejl p LED
			return					;afslut og vend tilbage
reenterPrgMem							;**** vend tilbage til prg-mem ****
			bsf		over2100			;vis EEdata-mode
			clrf		prog_picA0                  	;reset pic-adressen
			clrf		prog_picA1               	;	"
			nop						;pause
			nop						;pause
enterPrgMem							;**** g ind i prg-mem ****
			bcf		mclr				;\reset pic'en
			bsf		reset				;/      "	
			call		delay_10ms                	;pause
 			bcf		clock				;st clock til 0
			bcf		dataP                           	;st data til 0
			bsf		status,rp0			;st clock og data til output
			bcf		clockT			;		"
			bcf		dataT                         	;		"
			bcf		status,rp0			;		"
 			bcf		clock				;st clock til 0
			bcf		dataP                          	;st data til 0
			nop						;pause
			nop						;  "
			nop						;  "
			bcf		reset				;g i brnde mode
			bsf		mclr				;	"
			nop						;pause
			nop						;
			nop						;
			return					;afslut og vend tilbage
burnconf								;*** brnd configuratiop og afslut brnding ***
			call		reenterPrgMem		;g ind i prog-mode
			bcf		over2100			;men ikke i EEdata-mode
			movf		prog_con0,w		;
			movwf	prog_data0                	;hent configword (lav)
			movf		prog_con1,w		;
			movwf	prog_data1               	;hent configword (hj)
			movlw	D'0'				;load config cmd
			call		prog_cmd			;send cmd til pic'en
			call		prog_send_data     	;send data til pic'en
			call		flyt_til_2007               	;flyt til adr 2007	
			movlw	D'8'				;##################
			call		prog_cmd			;##################
			call		delay_10ms   		;##################
			goto		main				;brndingen frdig
flyt_til_2007                                                                	;forger fra adr 2000hex
			movlw	D'6'				;til 2007hex...
			call		prog_cmd			;
flyt_til_2006   							;(start her hvis det er ID, der skal lses)
			movlw	D'6'				;
			call		prog_cmd			;
			movlw	D'6'				;
			call		prog_cmd			;
			movlw	D'6'				;
			call		prog_cmd			;  (7 X incr-adr cmd)
			movlw	D'6'				;
			call		prog_cmd			;
			movlw	D'6'				;
			call		prog_cmd			;
			movlw	D'6'				;
			call		prog_cmd			;
			return					;
;********************** slet pic'en **********
sletPic
			clrf		prog_data0    		;procedure til at slette pic'en
			comf		prog_data0,f		;	"
			clrf		prog_data1    		;	"
			comf		prog_data1,f		;	"
			movlw	D'0'				;	"
			call		prog_cmd			;	"
			call		prog_send_data       	;	"
			call		flyt_til_2007    		;	"
			movlw	D'1'				;	"
			call		prog_cmd			;	"
			movlw	D'7'				;	"
			call		prog_cmd			;	"
			movlw	D'8'				;	"
			call		prog_cmd			;	"
			call		delay_10ms    		;	"
			movlw	D'1'				;	"
			call		prog_cmd			;	"
			movlw	D'7'				;	"
			call		prog_cmd			;	"
			movlw	B'11111'			;
			call		prog_cmd			;
			call		delay_10ms   		;
			call		reenterPrgMem		;
			bcf		over2100			;
			return					;	"
;*************** RecHex********************************
Read_Hex
			movwf	fsr				;st pointer til at modtage hexbyte
			clrf		indf				;slet destination
			Call		Nibble			;Modtag 4 bit i et hextegn
			swapf	indf,f				;swap det til highnibble
			goto		nibble  			;Modtag 4 bit igen
Nibble
			call		receive_wait    		;vent p et tegn p seriel port
			movlw	D'48'		           	;hex - 48  (vrdien af '0')
			subwf	receive,f			;
 			bcf		receive,5			;evt. korriger for smaa bogstaver i hex
			movlw	D'7'				;evt -7
			btfsc		receive,4			;test for strre end 16 ('A'..'F')
			subwf	receive,f       		;Her er recieve 0..15
			movf		receive,w			;
			iorwf		indf,f				;OR resultatet ind i INDR destination
			return					;
;*****************burner delay routine (EEPROM-kredse)*********
Delay_10ms							; 10,19ms = (772*21h+6)*400ns
			clrf		counter1			;nulstil tller 1
			movlw	0x21				;21h i w-reg.
			movwf	counter2			;lg 21h i tller 2
loop10ms								;**** loop ****
			decfsz	counter1,F			;forminsk tller 1 (resultat i tller)
			goto		loop10ms			;hvis tller ikke er nul: fortst loop
			decfsz	Counter2,F      		;ellers: forminsk tller 2 (resultat i tller)
			goto		loop10ms			;hvis tller ikke er nul: fortst loop
			return					;ellers: afslut og vend tilbage
;*****************burner delay routine (FLASH-kredse)**********
Delay_1ms							; 1,23ms = (772*4h+6)*400ns
			clrf		counter1			;nulstil tller 1
			movlw	0x4				;4h i w-reg.
			movwf	counter2			;lg 4h i tller 2
loop1ms								;**** loop ****
			decfsz	counter1,F			;forminsk tller 1 (resultat i tller)
			goto		loop1ms			;hvis tller ikke er nul: fortst loop
			decfsz	Counter2,F      		;ellers: forminsk tller 2 (resultat i tller)
			goto		loop1ms			;hvis tller ikke er nul: fortst loop
			return					;ellers: afslut og vend tilbage
;---------------------------------------------------------------------------------------
			end						;programmet er slut!!!!